program project1;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes
  { you can add units after this };

TYPE
  VocRecord = RECORD
    RecordNr : Integer;
    LessonNr : String[5];    // Lektion oder Kapitel Number
    IdentNr : String[15];
    VocNewDateTime : TDateTime;
    CreateUserName : String[15];  // who made this translation
    Category : String[15];
    VocChangeDateTime : Array [1..8] of TDateTime;
    VocChangeUserName : Array [1..8] of String[15];  // who made this translation
    NrOfRight : Array [1..8] of Integer;
    NrOfWrong : Array [1..8] of Integer;
    ActPoints : Array [1..8] of Integer;
    SysBlock : Array [1..8] of Boolean;
    UsrBlock : Array [1..8] of Boolean;
    Pons  : Array [1..8] of Boolean;
    CodeInfo    : Array [1..8] of Byte;
    LevelNr       : Array [1..8] of Integer;   // 0 = unlearned 9 = Learned
    LevelDateTime : Array [1..8] of TDateTime;
    VocGramType : Array [1..8] of Integer;
    VocLang1GenusMale    : Array [1..8] of Boolean;
    VocLang1GenusFemale  : Array [1..8] of Boolean;
    VocLang1GenusNeutral : Array [1..8] of Boolean;
    VocLangGenus : Array [1..8] of String[5];
    VocLang      : Array [1..8] of String[30];
    VocLangAlt   : Array [1..8] of String[30];       // Alternative 1 translation
    VocLangHelp  : Array [1..8] of String[30];
    VocLangLaut  : Array [1..8] of String[30];
  END;

  LibRecord = RECORD
    PrgName : String[15];
    PrgVers : String[15];
    PrgDate : String[15];
    ActLngNr : Integer;   // 1=English 2=German 3=French 4=Malgash
    SLang : Integer;   // Abfrage zb. von Deutsch = 2
    DLang : Integer;   // Engeben Antworten zb in Franz = 3
    DateTimeCreated : TDateTime;
    DateTimeLastSaved : TDateTime;
    DateTimeLastUsed : TDateTime; // What for?
    FileName : String[255];
    FileExt : String[5];        // Filename extension *.dat
    PathToData : String[255];
    ID : String[30];       // What for?
    UserName : String[30];  // who made this library
    Nr : Byte;       // what for ?
    ContainsData : Boolean;     // what for?
    NrOfVocables : integer;
    ActLibIndex : integer;
    ActLoopIndex : integer;
    LoopSize : Integer;
    MaxNrOfSpeedPoints : Integer;
    VocIndex : ARRAY [0..254] OF Integer;  // just keep the library record numbers
    CorrectLibInARow : Integer;
    IncreaseLoopSize : Integer;
    WrongLibInARow : Integer;
    DecreaseLoopSize : Integer;
    PointLossPerMinute : Integer;     // maybe not needed
    PointGoalPerDay : Integer;
    TodayInput : Integer;
    TodayRight : Integer;
    TodayWrong : Integer;
    TotalInputs : Integer;
    TotalRight : Integer;
    TotalWrong  : Integer;
    TodayLeveled : Integer;
    TotalLeveled : Integer;
    TodayLearned : Integer;
    TotalLearned : Integer;
    Lang1Nameq : String[30];
    Lang2Name : String[30];
    WordTypeShort : ARRAY [0..10] OF String[3];
    WordTypeTxt : ARRAY [0..10,0..8] OF String[30];
    WordTypeCnt : ARRAY [0..10,0..8] OF Integer;
    TodayNewVerb1 : String[15];
    TodayNewVerb2 : String[15];
    TodayOldVerb1 : String[15];
    TodayOldVerb2 : String[15];
    DailyPoints : Array[0..99] of Integer;
    DailyDate   : Array[0..99] of TDateTime;
    LevelRepeatArray : Array[1..12] of Integer;
    LevelReaskArray  : Array[1..12] of Integer;
    Data : ARRAY [0..5000] OF VocRecord;
    ControlNr : Byte;
  END;
  LibArray = ARRAY [1..1] OF LibRecord;

var
  LibDat : LibArray;
  LibDatei : FILE OF LibArray;

  LocTeiler: Integer;
  LocResult: Double;

begin
  // Das funktioniert
  LibDat[1].Data[4445].NrOfWrong[4] := 5;
  LocTeiler :=  LibDat[1].Data[4445].NrOfWrong[4];
  LocResult := 100 / LocTeiler;

  (*
  // Das funktioniert nicht, weil LocTeiler 0 ist.
  LocTeiler :=  LibDat[1].Data[4445].NrOfWrong[4];
  LibDat[1].Data[4445].NrOfWrong[4] := 5;
  LocResult := 100 / LocTeiler;
   *)

  WriteLn('LocResult = ',LocResult:0:3);
  WriteLn('ENTER druecken zum Beenden.');
  ReadLn;

end.

